## konsole 20.12.3

=== CMakeLists.txt ===
# Konsole project

# See comments in https://invent.kde.org/utilities/konsole/-/commit/9d8e47298c81fc1e47c998eda1b6e980589274eb
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)

# KDE Application Version, managed by release script
set (RELEASE_SERVICE_VERSION_MAJOR "20")
set (RELEASE_SERVICE_VERSION_MINOR "12")
set (RELEASE_SERVICE_VERSION_MICRO "3")
set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

# minimal requirements
cmake_minimum_required (VERSION 3.0 FATAL_ERROR)
# Qt 5.12 LTS EOL May 2021
set (QT_MIN_VERSION "5.12.0")

# Ubuntu 20.04 LTS only has KF 5.68 and Qt 5.12
set (KF5_MIN_VERSION "5.68.0")

# Release script will create bugzilla versions
project(konsole VERSION ${RELEASE_SERVICE_VERSION})

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(GenerateExportHeader)
include(FeatureSummary)
include(ECMQtDeclareLoggingCategory)

ecm_setup_version(${RELEASE_SERVICE_VERSION} VARIABLE_PREFIX KONSOLEPRIVATE
    SOVERSION ${RELEASE_SERVICE_VERSION_MAJOR}
)
find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED
    Core
    DBus
    PrintSupport
    Widgets
)

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED
    Bookmarks Completion Config ConfigWidgets
    CoreAddons Crash GuiAddons DBusAddons
    I18n IconThemes Init KIO NewStuff NewStuffCore Notifications NotifyConfig
    Parts Pty Service TextWidgets WidgetsAddons
    WindowSystem XmlGui DBusAddons GlobalAccel
)

find_package(KF5DocTools ${KF5_MIN_VERSION})
set_package_properties(KF5DocTools PROPERTIES DESCRIPTION
    "Tools to generate documentation"
    TYPE OPTIONAL
)

if(NOT APPLE)
    find_package(X11)
    set_package_properties(X11 PROPERTIES TYPE OPTIONAL)
endif()
set(HAVE_X11 ${X11_FOUND})

# See above includes for defaults
add_definitions(
  -DQT_NO_FOREACH
  -DQT_STRICT_ITERATORS
  -DQT_NO_URL_CAST_FROM_STRING
)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} )

file(GLOB ICONS_SRCS "data/icons/*.png")

add_subdirectory( src )
add_subdirectory( data )
add_subdirectory( desktop )
if (KF5DocTools_FOUND)
    add_subdirectory( doc/manual )
endif()

add_subdirectory( tools )

# Conditionally install icons for Linux as they may not be provided by the user theme
option(INSTALL_ICONS "Install icons" OFF)
if (INSTALL_ICONS)
    include(ECMInstallIcons)
    ecm_install_icons( ICONS ${ICONS_SRCS} DESTINATION ${KDE_INSTALL_ICONDIR} )
endif()


if (${ECM_VERSION} STRGREATER "5.58.0")
    install( FILES konsole.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR} )
else()
    install( FILES konsole.categories DESTINATION ${KDE_INSTALL_CONFDIR} )
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)
ki18n_install(po)
if (KF5DocTools_FOUND)
 kdoctools_install(po)
endif()

=== data/CMakeLists.txt ===

add_subdirectory( color-schemes )
add_subdirectory( keyboard-layouts )

install( FILES konsole.knsrc DESTINATION ${KDE_INSTALL_KNSRCDIR})

=== desktop/CMakeLists.txt ===


########### install files ###############

install( PROGRAMS org.kde.konsole.desktop  DESTINATION ${KDE_INSTALL_APPDIR} )
install( FILES org.kde.konsole.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR} )
install( FILES terminalemulator.desktop    DESTINATION ${KDE_INSTALL_KSERVICETYPES5DIR} )
install( FILES konsolepart.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR} )
install( FILES konsolehere.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR}/ServiceMenus )
install( FILES konsolerun.desktop  DESTINATION ${KDE_INSTALL_KSERVICES5DIR}/ServiceMenus )
install( FILES konsole.khotkeys DESTINATION ${DATA_INSTALL_DIR}/khotkeys )
install( FILES konsole.notifyrc DESTINATION  ${KDE_INSTALL_KNOTIFY5RCDIR} )

=== src/CMakeLists.txt ===
# cmake-options : -DCMAKE_DISABLE_FIND_PACKAGE_LibKonq=TRUE or FALSE; default is FALSE

add_definitions(-DTRANSLATION_DOMAIN=\"konsole\")

### Handle DragonFlyBSD here instead of using __DragonFly__
IF(${CMAKE_SYSTEM_NAME} MATCHES "DragonFly")
  set(HAVE_OS_DRAGONFLYBSD 1)
else()
  set(HAVE_OS_DRAGONFLYBSD 0)
endif()

IF(NOT (${KF5_VERSION} VERSION_LESS "5.60.0"))
    set(USE_TERMINALINTERFACEV2 1)
endif()

include(CheckIncludeFiles)
include(ECMAddAppIcon)

configure_file(config-konsole.h.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/config-konsole.h)

### Tests
if(BUILD_TESTING)
  find_package(Qt5Test ${QT_MIN_VERSION} CONFIG REQUIRED)
  add_subdirectory(autotests)
  add_subdirectory(tests)
endif()

### Security concerns about sendText and runCommand dbus methods being public
option(REMOVE_SENDTEXT_RUNCOMMAND_DBUS_METHODS "Konsole: remove sendText and runCommand dbus methods" OFF)

### Development tools
option(KONSOLE_BUILD_UNI2CHARACTERWIDTH "Konsole: build uni2characterwidth executable" OFF)

### Konsole source files shared between embedded terminal and main application
# qdbuscpp2xml -m  Session.h -o org.kde.konsole.Session.xml
# qdbuscpp2xml -M -s ViewManager.h -o org.kde.konsole.Konsole.xml

# Generate dbus .xml files; do not store .xml in source folder
qt5_generate_dbus_interface(ViewManager.h org.kde.konsole.Window.xml OPTIONS -m)

qt5_add_dbus_adaptor(windowadaptors_SRCS
                    ${CMAKE_CURRENT_BINARY_DIR}/org.kde.konsole.Window.xml
                    ViewManager.h
                    Konsole::ViewManager)


set(konsole_LIBS
    KF5::XmlGui
    Qt5::PrintSupport
    Qt5::Xml
    KF5::Notifications
    KF5::WindowSystem
    KF5::TextWidgets
    KF5::GuiAddons
    KF5::IconThemes
    KF5::Bookmarks
    KF5::I18n
    KF5::Pty
    KF5::KIOWidgets
    KF5::DBusAddons
    KF5::GlobalAccel
    KF5::NewStuff
)

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    #kinfo_getfile() is in libutil
    list(APPEND konsole_LIBS util)
endif()

# TODO: Move this to an internal folder if it grows too much.
# This konsoleprivate_core is the "core" library that depends in nothing from konsole itself
# so we can start to detangle the codebase.
set(konsoleprivate_core_SRCS
    ShellCommand.cpp
    WindowSystemInfo.cpp
)

ecm_qt_declare_logging_category(
    konsoleprivate_core_SRCS
    HEADER konsoledebug.h
    IDENTIFIER KonsoleDebug
    CATEGORY_NAME org.kde.konsole
)

add_library(konsoleprivate_core STATIC ${konsoleprivate_core_SRCS})
target_link_libraries(konsoleprivate_core ${konsole_LIBS})

set(konsolehelpers_SRCS
    LabelsAligner.cpp
)
add_library(konsolehelpers
    STATIC
    ${konsolehelpers_SRCS}
)
target_link_libraries(konsolehelpers
    Qt5::Core
    Qt5::Widgets
)

add_subdirectory(colorscheme)
add_subdirectory(keyboardtranslator)
add_subdirectory(profile)
add_subdirectory(session)
add_subdirectory(characters)

set(konsoleprivate_SRCS ${windowadaptors_SRCS}
                        BookmarkHandler.cpp
                        BookmarkMenu.cpp
                        CheckableSessionModel.cpp
                        CopyInputDialog.cpp
                        Emulation.cpp
                        EscapeSequenceUrlExtractor.cpp
                        ExtendedCharTable.cpp
                        FontDialog.cpp
                        HTMLDecoder.cpp
                        HistorySizeDialog.cpp
                        KeyBindingEditor.cpp
                        LabelsAligner.cpp
                        NullProcessInfo.cpp
                        NullProcessInfo.cpp
                        PlainTextDecoder.cpp
                        PrintOptions.cpp
                        PrintOptions.cpp
                        ProcessInfo.cpp
                        ProcessInfo.cpp
                        Pty.cpp
                        Pty.cpp
                        RenameTabDialog.cpp
                        SSHProcessInfo.cpp
                        SaveHistoryTask.cpp
                        Screen.cpp
                        ScreenWindow.cpp
                        ScrollState.cpp
                        SearchHistoryTask.cpp
                        ShouldApplyProperty.cpp
                        UnixProcessInfo.cpp
                        ViewManager.cpp
                        ViewProperties.cpp
                        Vt102Emulation.cpp
                        WindowSystemInfo.cpp
                        ZModemDialog.cpp
                        filterHotSpots/EscapeSequenceUrlFilter.cpp
                        filterHotSpots/EscapeSequenceUrlFilterHotSpot.cpp
                        filterHotSpots/FileFilter.cpp
                        filterHotSpots/FileFilterHotspot.cpp
                        filterHotSpots/Filter.cpp
                        filterHotSpots/FilterChain.cpp
                        filterHotSpots/HotSpot.cpp
                        filterHotSpots/RegExpFilter.cpp
                        filterHotSpots/RegExpFilterHotspot.cpp
                        filterHotSpots/TerminalImageFilterChain.cpp
                        filterHotSpots/UrlFilter.cpp
                        filterHotSpots/UrlFilterHotspot.cpp
                        history/HistoryFile.cpp
                        history/HistoryScroll.cpp
                        history/HistoryScrollFile.cpp
                        history/HistoryScrollNone.cpp
                        history/HistoryType.cpp
                        history/HistoryTypeFile.cpp
                        history/HistoryTypeNone.cpp
                        history/compact/CompactHistoryBlock.cpp
                        history/compact/CompactHistoryBlockList.cpp
                        history/compact/CompactHistoryLine.cpp
                        history/compact/CompactHistoryScroll.cpp
                        history/compact/CompactHistoryType.cpp
                        widgets/DetachableTabBar.cpp
                        widgets/DetachableTabBar.cpp
                        widgets/EditProfileDialog.cpp
                        widgets/HistorySizeWidget.cpp
                        widgets/HistorySizeWidget.cpp
                        widgets/IncrementalSearchBar.cpp
                        widgets/IncrementalSearchBar.cpp
                        widgets/RenameTabWidget.cpp
                        widgets/RenameTabWidget.cpp
                        widgets/TabTitleFormatButton.cpp

                        terminalDisplay/extras/CompositeWidgetFocusWatcher.cpp
                        terminalDisplay/extras/AutoScrollHandler.cpp

                        terminalDisplay/TerminalDisplay.cpp
                        terminalDisplay/TerminalPainter.cpp
                        terminalDisplay/TerminalScrollBar.cpp

                        widgets/TerminalDisplayAccessible.cpp
                        widgets/TerminalHeaderBar.cpp
                        widgets/ViewContainer.cpp
                        widgets/ViewSplitter.cpp
                        widgets/KonsolePrintManager.cpp
                        ${CMAKE_CURRENT_BINARY_DIR}/org.kde.konsole.Window.xml)

kconfig_add_kcfg_files(konsoleprivate_SRCS settings/KonsoleSettings.kcfgc)

### Konsole Application

ki18n_wrap_ui(konsoleprivate_SRCS
    CopyInputDialog.ui
    HistorySizeDialog.ui
    KeyBindingEditor.ui
    PrintOptions.ui       # Temporary to build session static library
    RenameTabDialog.ui
    settings/GeneralSettings.ui
    settings/PartInfo.ui
    settings/ProfileSettings.ui
    settings/TabBarSettings.ui
    settings/TemporaryFilesSettings.ui
    settings/ThumbnailsSettings.ui
    widgets/EditProfileAdvancedPage.ui
    widgets/EditProfileAppearancePage.ui
    widgets/EditProfileGeneralPage.ui
    widgets/EditProfileKeyboardPage.ui
    widgets/EditProfileMousePage.ui
    widgets/EditProfileScrollingPage.ui
    widgets/EditProfileTabsPage.ui
    widgets/HistorySizeWidget.ui
    widgets/RenameTabWidget.ui
)

# add the resource files for the ui files
qt5_add_resources( konsoleprivate_SRCS ../desktop/konsole.qrc)

add_library(konsoleprivate ${konsoleprivate_SRCS})
generate_export_header(konsoleprivate BASE_NAME konsoleprivate)

target_link_libraries(konsoleprivate
    PUBLIC
    konsoleprivate_core
    konsolecolorscheme
    keyboardtranslator
    konsolehelpers
    konsolesession
    konsoleprofile
    konsolecharacters
    ${konsole_LIBS}
)

set_target_properties(konsoleprivate PROPERTIES
    VERSION ${KONSOLEPRIVATE_VERSION_STRING}
    SOVERSION ${KONSOLEPRIVATE_SOVERSION}
)

install(TARGETS konsoleprivate ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)

set(konsole_KDEINIT_SRCS
   Application.cpp
   MainWindow.cpp
   main.cpp
   settings/ConfigurationDialog.cpp
   settings/ConfigDialogButtonGroupManager.cpp
   settings/TemporaryFilesSettings.cpp
   settings/GeneralSettings.cpp
   settings/ProfileSettings.cpp
   settings/TabBarSettings.cpp
   settings/ThumbnailsSettings.cpp
   delegates/ProfileShortcutDelegate.cpp
)


# Sets the icon on Windows and OSX
ecm_add_app_icon(kdeinit_konsole ICONS ${ICONS_SRCS})

kf5_add_kdeinit_executable(konsole ${konsole_KDEINIT_SRCS})
target_link_libraries(kdeinit_konsole
  konsoleprivate
  KF5::XmlGui
  KF5::WindowSystem
  KF5::Bookmarks
  KF5::I18n
  KF5::KIOWidgets
  KF5::NotifyConfig
  KF5::Crash
)

if(APPLE)
    set_target_properties(konsole PROPERTIES
        MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.konsole"
        MACOSX_BUNDLE_BUNDLE_NAME "Konsole"
        MACOSX_BUNDLE_DISPLAY_NAME "Konsole"
        MACOSX_BUNDLE_INFO_STRING "Konsole, the KDE terminal emulator"
        MACOSX_BUNDLE_LONG_VERSION_STRING "Konsole ${RELEASE_SERVICE_VERSION}"
        MACOSX_BUNDLE_SHORT_VERSION_STRING "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}"
        MACOSX_BUNDLE_BUNDLE_VERSION "${RELEASE_SERVICE_VERSION}"
        MACOSX_BUNDLE_COPYRIGHT "1997-2020 The Konsole Developers")
endif()

install(TARGETS kdeinit_konsole konsole
       ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

### Embedded Konsole KPart

set(konsolepart_PART_SRCS Part.cpp
    settings/PartInfo.cpp
    settings/ProfileSettings.cpp
    delegates/ProfileShortcutDelegate.cpp
)

add_library(konsolepart MODULE ${konsolepart_PART_SRCS})
generate_export_header(konsolepart BASE_NAME konsole)
kcoreaddons_desktop_to_json(konsolepart ../desktop/konsolepart.desktop)
set_target_properties(konsolepart PROPERTIES DEFINE_SYMBOL KONSOLE_PART)
target_link_libraries(konsolepart
    KF5::Parts
    KF5::XmlGui
    konsoleprivate
)
install(TARGETS konsolepart  DESTINATION ${KDE_INSTALL_PLUGINDIR})

=== doc/manual/CMakeLists.txt ===
########### install files ###############

KDOCTOOLS_CREATE_HANDBOOK(index.docbook
                     INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en
                     SUBDIR konsole)

=== src/autotests/CMakeLists.txt ===
include(ECMMarkAsTest)
include(ECMMarkNonGuiExecutable)

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

set(KONSOLE_TEST_LIBS Qt5::Test konsoleprivate)

add_executable(BookMarkTest BookMarkTest.cpp)
ecm_mark_as_test(BookMarkTest)
ecm_mark_nongui_executable(BookMarkTest)
add_test(NAME BookMarkTest COMMAND BookMarkTest)
target_link_libraries(BookMarkTest ${KONSOLE_TEST_LIBS})

add_executable(CharacterColorTest CharacterColorTest.cpp)
ecm_mark_as_test(CharacterColorTest)
ecm_mark_nongui_executable(CharacterColorTest)
add_test(NAME CharacterColorTest COMMAND CharacterColorTest)
target_link_libraries(CharacterColorTest ${KONSOLE_TEST_LIBS})

add_executable(CharacterWidthTest CharacterWidthTest.cpp)
ecm_mark_as_test(CharacterWidthTest)
ecm_mark_nongui_executable(CharacterWidthTest)
add_test(NAME CharacterWidthTest COMMAND CharacterWidthTest)
target_link_libraries(CharacterWidthTest ${KONSOLE_TEST_LIBS})

if ("$ENV{USER}" STREQUAL "jenkins")
    message(STATUS "We are running in jenkins; skipping DBusTest...")
else()
    message(STATUS "We are NOT running in jenkins; running DBusTest...")

    # This test fails on kf5-qt5 SUSEQt5.9 buildbot since Oct 28, 2018
    # Believed due to frameworks regession; disable to avoid sysadmins having
    # to fix for every build
    # https://mail.kde.org/pipermail/kde-frameworks-devel/2018-November/073078.html
    # https://phabricator.kde.org/T9948
    if (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
        add_executable(DBusTest DBusTest.cpp)
        ecm_mark_as_test(DBusTest)
        ecm_mark_nongui_executable(DBusTest)
        add_test(NAME DBusTest COMMAND DBusTest)
        target_link_libraries(DBusTest ${KONSOLE_TEST_LIBS} Qt5::DBus)
    endif()
endif()

add_executable(HistoryTest HistoryTest.cpp)
ecm_mark_as_test(HistoryTest)
ecm_mark_nongui_executable(HistoryTest)
add_test(NAME HistoryTest COMMAND HistoryTest)
target_link_libraries(HistoryTest ${KONSOLE_TEST_LIBS} KF5::Parts)

add_executable(KeyboardTranslatorTest KeyboardTranslatorTest.cpp)
ecm_mark_as_test(KeyboardTranslatorTest)
ecm_mark_nongui_executable(KeyboardTranslatorTest)
add_test(NAME KeyboardTranslatorTest COMMAND KeyboardTranslatorTest)
target_link_libraries(KeyboardTranslatorTest ${KONSOLE_TEST_LIBS})

if (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    add_executable(PartTest PartTest.cpp)
    ecm_mark_as_test(PartTest)
    ecm_mark_nongui_executable(PartTest)
    add_test(NAME PartTest COMMAND PartTest)
    target_link_libraries(PartTest KF5::XmlGui KF5::Parts KF5::Pty
                               ${KONSOLE_TEST_LIBS})
endif()

add_executable(ProfileTest ProfileTest.cpp)
ecm_mark_as_test(ProfileTest)
ecm_mark_nongui_executable(ProfileTest)
add_test(NAME ProfileTest COMMAND ProfileTest)
target_link_libraries(ProfileTest ${KONSOLE_TEST_LIBS})

add_executable(PtyTest PtyTest.cpp)
ecm_mark_as_test(PtyTest)
ecm_mark_nongui_executable(PtyTest)
add_test(NAME PtyTest COMMAND PtyTest)
target_link_libraries(PtyTest KF5::Pty ${KONSOLE_TEST_LIBS})

add_executable(SessionTest SessionTest.cpp)
ecm_mark_as_test(SessionTest)
ecm_mark_nongui_executable(SessionTest)
add_test(NAME SessionTest COMMAND SessionTest)
target_link_libraries(SessionTest ${KONSOLE_TEST_LIBS} KF5::Parts)

add_executable(ShellCommandTest ShellCommandTest.cpp)
ecm_mark_as_test(ShellCommandTest)
ecm_mark_nongui_executable(ShellCommandTest)
add_test(NAME ShellCommandTest COMMAND ShellCommandTest)
target_link_libraries(ShellCommandTest ${KONSOLE_TEST_LIBS})

add_executable(ScreenTest ScreenTest.cpp)
ecm_mark_as_test(ScreenTest)
ecm_mark_nongui_executable(ScreenTest)
add_test(NAME ScreenTest COMMAND ScreenTest)
target_link_libraries(ScreenTest ${KONSOLE_TEST_LIBS})

add_executable(TerminalCharacterDecoderTest
               TerminalCharacterDecoderTest.cpp)
ecm_mark_as_test(TerminalCharacterDecoderTest)
ecm_mark_nongui_executable(TerminalCharacterDecoderTest)
add_test(NAME TerminalCharacterDecoderTest COMMAND TerminalCharacterDecoderTest)
target_link_libraries(TerminalCharacterDecoderTest ${KONSOLE_TEST_LIBS})

add_executable(TerminalTest TerminalTest.cpp)
ecm_mark_as_test(TerminalTest)
ecm_mark_nongui_executable(TerminalTest)
add_test(NAME TerminalTest COMMAND TerminalTest)
target_link_libraries(TerminalTest ${KONSOLE_TEST_LIBS} KF5::Parts)

add_executable(TerminalInterfaceTest TerminalInterfaceTest.cpp)
ecm_mark_as_test(TerminalInterface)
ecm_mark_nongui_executable(TerminalInterfaceTest)
add_test(NAME TerminalInterfaceTest COMMAND TerminalInterfaceTest)
target_link_libraries(TerminalInterfaceTest
                      KF5::Parts
                      ${KONSOLE_TEST_LIBS})

add_executable(Vt102EmulationTest Vt102EmulationTest.cpp)
ecm_mark_as_test(Vt102EmulationTest)
ecm_mark_nongui_executable(Vt102EmulationTest)
add_test(NAME Vt102EmulationTest COMMAND Vt102EmulationTest)
target_link_libraries(Vt102EmulationTest ${KONSOLE_TEST_LIBS})

=== src/characters/CMakeLists.txt ===

add_library(konsolecharacters
    OBJECT
    CharacterFormat.cpp
    CharacterWidth.cpp
    LineBlockCharacters.cpp
)
generate_export_header(konsolecharacters BASE_NAME konsolecharacters)
target_include_directories(konsolecharacters PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(konsolecharacters Qt5::Gui)

=== src/colorscheme/CMakeLists.txt ===

set(konsole_colorscheme_SRCS
    hsluv.c
    ColorScheme.cpp
    ColorSchemeManager.cpp
    ColorSchemeWallpaper.cpp
    ColorSchemeEditor.cpp
    ColorSchemeViewDelegate.cpp
)

ki18n_wrap_ui(konsole_colorscheme_SRCS
    ColorSchemeEditor.ui
)

ecm_qt_declare_logging_category(
    konsole_colorscheme_SRCS
    HEADER colorschemedebug.h
    IDENTIFIER ColorSchemeDebug
    CATEGORY_NAME org.kde.konsole.colorScheme
)

add_library(konsolecolorscheme
    STATIC
    ${konsole_colorscheme_SRCS}
)
generate_export_header(konsolecolorscheme BASE_NAME konsolecolorscheme)
target_include_directories(konsolecolorscheme PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(
    konsolecolorscheme
    ${konsole_LIBS}
)

=== tools/uni2characterwidth/CMakeLists.txt ===
### uni2characterwidth
###
###   Converts Unicode Character Database files into character width lookup
###   tables. Uses a template file to place the tables in a source code file
###   together with a function for finding the width for specified character.
###
###   See `uni2characterwidth --help` for usage information
if(KONSOLE_BUILD_UNI2CHARACTERWIDTH)

    find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED
        Core
    )
    find_package(KF5 ${KF5_MIN_VERSION} REQUIRED
        KIO
    )

    set(uni2characterwidth_SRC
        uni2characterwidth.cpp
        properties.h
        template.cpp
        template.h
    )

    add_executable(uni2characterwidth ${uni2characterwidth_SRC})
    target_link_libraries(uni2characterwidth
        Qt5::Core
        KF5::KIOCore
    )

endif()

=== debian/changelog ===
konsole (4:20.12.3-1) unstable; urgency=medium

  * New upstream release (20.12.3).
  * Removed Maximiliano Curia, Modestas Vainius from the uploaders,
    thanks for your work on the package!
  * Added myself to the uploaders.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 08 Mar 2021 22:56:09 +0100

konsole (4:20.12.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update upstream GPG signing key.

 -- Pino Toscano <pino@debian.org>  Thu, 04 Feb 2021 14:59:41 +0100

konsole (4:20.12.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release (20.12.1).
  * Drop patch revert-upstream-bold-color-paint, fixed upstream.

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 07 Jan 2021 23:00:00 +0100

konsole (4:20.12.0-2) unstable; urgency=medium

  * Team upload.
  * Revert upstream change with respect to bold and intense colors
    (debian/patches/revert-upstream-bold-color-paint)
    (Thanks to Antonio Russo) (Closes: #977338)

 -- Norbert Preining <norbert@preining.info>  Tue, 15 Dec 2020 09:39:41 +0900

konsole (4:20.12.0-1) unstable; urgency=medium

  * Team upload.

  [ Norbert Preining ]
  * New upstream release (20.12.0).
  * Update build-deps and deps with the info from cmake.
  * Bump Standards-Version to 4.5.1 (no change required).

  [ Aurélien COUDERC ]
  * Refresh copyright information.
  * Refresh upstream metadata: remove Contact field already in machine
    readable copyright, simplyfy Bug-Database URL.
  * Remove unused lintian override konsole-dbgsym: stripped-library.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 12 Dec 2020 00:33:59 +0100

konsole (4:20.08.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release (20.08.3).
  * Drop lintian override for tag postinst-must-call-ldconfig that was removed
    from lintian.
  * Review copyright information.
  * Drop l10n migration rules, not required anymore after 2 stable releases.
  * Build with hardening=+all build hardening flag.
  * Borrow minimal upstream signing key from k3b.
  * Refresh upstream metadata.
  * Override lintian error that konsole.debug doesn’t contain debug
    information.

 -- Aurélien COUDERC <coucouf@debian.org>  Fri, 13 Nov 2020 23:42:55 +0100

=== debian/control ===
Source: konsole
Section: kde
Priority: optional
Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Sune Vuorela <sune@debian.org>,
Build-Depends: cmake (>= 3.13~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.68.0~),
               gettext,
               kinit-dev (>= 5.68.0~),
               libkf5bookmarks-dev (>= 5.68.0~),
               libkf5completion-dev (>= 5.68.0~),
               libkf5config-dev (>= 5.68.0~),
               libkf5configwidgets-dev (>= 5.68.0~),
               libkf5coreaddons-dev (>= 5.68.0~),
               libkf5crash-dev (>= 5.68.0~),
               libkf5dbusaddons-dev (>= 5.68.0~),
               libkf5doctools-dev (>= 5.68.0~),
               libkf5globalaccel-dev (>= 5.68.0~),
               libkf5guiaddons-dev (>= 5.68.0~),
               libkf5i18n-dev (>= 5.68.0~),
               libkf5iconthemes-dev (>= 5.68.0~),
               libkf5kio-dev (>= 5.68.0~),
               libkf5newstuff-dev (>= 5.68.0~),
               libkf5notifications-dev (>= 5.68.0~),
               libkf5notifyconfig-dev (>= 5.68.0~),
               libkf5parts-dev (>= 5.68.0~),
               libkf5pty-dev (>= 5.68.0~),
               libkf5service-dev (>= 5.68.0~),
               libkf5textwidgets-dev (>= 5.68.0~),
               libkf5widgetsaddons-dev (>= 5.68.0~),
               libkf5windowsystem-dev (>= 5.68.0~),
               libkf5xmlgui-dev (>= 5.68.0~),
               libx11-dev,
               pkg-kde-tools (>= 0.15.16~),
               qtbase5-dev (>= 5.12.0~)
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://apps.kde.org/en/konsole
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/konsole
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/konsole.git

Package: konsole
Architecture: any
Depends: konsole-kpart (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: lrzsz
Provides: x-terminal-emulator
Description: X terminal emulator
 Konsole is a terminal emulator built on the KDE Platform. It can contain
 multiple terminal sessions inside one window using detachable tabs.
 .
 Konsole supports powerful terminal features, such as customizable schemes,
 saved sessions, and output monitoring.

Package: konsole-kpart
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: konsole (<< 4:17.08.3~)
Replaces: konsole (<< 4:17.08.3~)
Description: Konsole plugin for Qt applications
 Konsole is a terminal emulator built on the KDE Platform. It can contain
 multiple terminal sessions inside one window using detachable tabs.
 .
 Konsole supports powerful terminal features, such as customizable schemes,
 saved sessions, and output monitoring.
 .
 This package provides the kpart needed by other apps to embed konsole in
 them.

## konsole 21.08.1

=== CMakeLists.txt ===
# Konsole project

# KDE Application Version, managed by release script
set (RELEASE_SERVICE_VERSION_MAJOR "21")
set (RELEASE_SERVICE_VERSION_MINOR "08")
set (RELEASE_SERVICE_VERSION_MICRO "1")
set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

# Do not increase these requirements without a merge-request or/and
# approval from maintainer(s).
# minimal requirements

# See comments in https://invent.kde.org/utilities/konsole/-/commit/9d8e47298c81fc1e47c998eda1b6e980589274eb
cmake_minimum_required(VERSION 3.13 FATAL_ERROR)

# Match KDE Frameworks update Apr 2021
set (QT_MIN_VERSION "5.15.0")

set (KF5_MIN_VERSION "5.71.0")

# Release script will create bugzilla versions
project(konsole VERSION ${RELEASE_SERVICE_VERSION})

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(GenerateExportHeader)
include(FeatureSummary)
include(ECMQtDeclareLoggingCategory)
include(KDEClangFormat)


# Allows passing e.g. -DECM_ENABLE_SANITIZERS='address;undefined' to cmake.
include(ECMEnableSanitizers)

ecm_setup_version(${RELEASE_SERVICE_VERSION} VARIABLE_PREFIX KONSOLEPRIVATE
    SOVERSION ${RELEASE_SERVICE_VERSION_MAJOR}
)
find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED
    Core
    DBus
    PrintSupport
    Widgets
)

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED
    Bookmarks
    Config
    ConfigWidgets
    CoreAddons
    Crash
    GlobalAccel
    GuiAddons
    DBusAddons
    I18n
    IconThemes
    KIO
    NewStuff
    NewStuffCore
    Notifications
    NotifyConfig
    Parts
    Pty
    Service
    TextWidgets
    WidgetsAddons
    WindowSystem
    XmlGui
)

find_package(KF5DocTools ${KF5_MIN_VERSION})
set_package_properties(KF5DocTools PROPERTIES DESCRIPTION
    "Tools to generate documentation"
    TYPE OPTIONAL
)

if(NOT APPLE)
    find_package(X11)
    set_package_properties(X11 PROPERTIES TYPE OPTIONAL)
endif()
set(HAVE_X11 ${X11_FOUND})

# Check for function GETPWUID
check_symbol_exists(getpwuid "pwd.h" HAVE_GETPWUID)

# See above includes for defaults
add_definitions(
  -DQT_NO_FOREACH
  -DQT_STRICT_ITERATORS
  -DQT_NO_URL_CAST_FROM_STRING
)

# FIXME: on my system coverity build doesn't work with 17; change to 11 to
#        get a scan
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} )

file(GLOB ICONS_SRCS "data/icons/*.png")

add_subdirectory( src )
add_subdirectory( data )
add_subdirectory( desktop )
if (KF5DocTools_FOUND)
    add_subdirectory( doc/manual )
endif()

add_subdirectory( tools )

# Conditionally install icons for Linux as they may not be provided by the user theme
option(INSTALL_ICONS "Install icons" OFF)
if (INSTALL_ICONS)
    include(ECMInstallIcons)
    ecm_install_icons( ICONS ${ICONS_SRCS} DESTINATION ${KDE_INSTALL_ICONDIR} )
endif()

ecm_qt_install_logging_categories(
    EXPORT KONSOLE
    FILE konsole.categories
    DESTINATION "${KDE_INSTALL_LOGGINGCATEGORIESDIR}"
)

option(ENABLE_PLUGIN_SSHMANAGER OFF)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

# Do not do bulk whitespace/style changes without MRs and maintainer(s)
# approval.  clang-format executeable needs to be installed prior to initial
# building; then do make clang-format.
# add clang-format target for all our real source files
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.c *.cpp *.h *.hpp)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
# Let's not do pre-hooks yet
#kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
ki18n_install(po)
if (KF5DocTools_FOUND)
 kdoctools_install(po)
endif()

=== debian/changelog ===
konsole (4:21.08.1-1ubuntu1) impish; urgency=medium

  * Fix lintian overrides.
  * Cherry pick upstream bugfixes scheduled for 21.08.2
    - upstream_fix-bug-401898.patch
    - upstream_fix-bug-441199.patch
    - upstream_fix-bug-441889.patch
    - upstream_fix-bug-432077.patch
    - upstream_fix-bug-441610.patch

 -- Rik Mills <rikmills@kde.org>  Wed, 15 Sep 2021 19:09:20 +0100

konsole (4:21.08.1-1) unstable; urgency=medium

  [ Norbert Preining ]
  * Drop upstream patches.
  * Bump standards version, no changes necessary.

 -- Norbert Preining <norbert@preining.info>  Thu, 02 Sep 2021 23:41:06 +0900

konsole (4:21.08.0-1) unstable; urgency=medium

  [ Norbert Preining ]
  * New upstream release (21.08.0).
  * Activate plugin manager and install new files.
  * Cherry pick two upstream fixes for main window size.

 -- Norbert Preining <norbert@preining.info>  Wed, 18 Aug 2021 15:44:43 +0900

konsole (4:21.04.2-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (21.04.2).
  * Drop upstream patch.

 -- Norbert Preining <norbert@preining.info>  Thu, 10 Jun 2021 19:38:24 +0900

konsole (4:21.04.1-2) experimental; urgency=medium

  [ Norbert Preining ]
  * Cherry-pick upstream fix for alpha-channel of scrollbars.

 -- Norbert Preining <norbert@preining.info>  Wed, 26 May 2021 05:13:15 +0900

konsole (4:21.04.1-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (21.04.1).
  * Drop Kubuntu from maintainer name.

 -- Norbert Preining <norbert@preining.info>  Fri, 14 May 2021 05:45:34 +0900

konsole (4:21.04.0-1) experimental; urgency=medium

  [ Norbert Preining ]
  * New upstream release (21.04.0).
  * Update dependencies.
  * Update list of installed files.
  * Add myself to uploaders.

 -- Norbert Preining <norbert@preining.info>  Fri, 23 Apr 2021 08:06:08 +0900

## konsole 21.08.2

=== debian/control ===
Source: konsole
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Sune Vuorela <sune@debian.org>,
           Norbert Preining <norbert@preining.info>,
Build-Depends: cmake (>= 3.13~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.71.0~),
               gettext,
               kinit-dev (>= 5.71.0~),
               libkf5bookmarks-dev (>= 5.71.0~),
               libkf5completion-dev (>= 5.71.0~),
               libkf5config-dev (>= 5.71.0~),
               libkf5configwidgets-dev (>= 5.71.0~),
               libkf5coreaddons-dev (>= 5.71.0~),
               libkf5crash-dev (>= 5.71.0~),
               libkf5dbusaddons-dev (>= 5.71.0~),
               libkf5doctools-dev (>= 5.71.0~),
               libkf5globalaccel-dev (>= 5.71.0~),
               libkf5guiaddons-dev (>= 5.71.0~),
               libkf5i18n-dev (>= 5.71.0~),
               libkf5iconthemes-dev (>= 5.71.0~),
               libkf5kio-dev (>= 5.71.0~),
               libkf5newstuff-dev (>= 5.71.0~),
               libkf5notifications-dev (>= 5.71.0~),
               libkf5notifyconfig-dev (>= 5.71.0~),
               libkf5parts-dev (>= 5.71.0~),
               libkf5pty-dev (>= 5.71.0~),
               libkf5service-dev (>= 5.71.0~),
               libkf5textwidgets-dev (>= 5.71.0~),
               libkf5widgetsaddons-dev (>= 5.71.0~),
               libkf5windowsystem-dev (>= 5.71.0~),
               libkf5xmlgui-dev (>= 5.71.0~),
               libx11-dev,
               pkg-kde-tools (>= 0.15.16~),
               qtbase5-dev (>= 5.15.0~),
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://apps.kde.org/en/konsole
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/konsole
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/konsole.git

Package: konsole
Architecture: any
Depends: konsole-kpart (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: lrzsz
Provides: x-terminal-emulator
Description: X terminal emulator
 Konsole is a terminal emulator built on the KDE Platform. It can contain
 multiple terminal sessions inside one window using detachable tabs.
 .
 Konsole supports powerful terminal features, such as customizable schemes,
 saved sessions, and output monitoring.

Package: konsole-kpart
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: konsole (<< 4:17.08.3~)
Replaces: konsole (<< 4:17.08.3~)
Description: Konsole plugin for Qt applications
 Konsole is a terminal emulator built on the KDE Platform. It can contain
 multiple terminal sessions inside one window using detachable tabs.
 .
 Konsole supports powerful terminal features, such as customizable schemes,
 saved sessions, and output monitoring.
 .
 This package provides the kpart needed by other apps to embed konsole in
 them.

## konsole 21.12.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 
 # KDE Application Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "21")
-set (RELEASE_SERVICE_VERSION_MINOR "08")
-set (RELEASE_SERVICE_VERSION_MICRO "1")
+set (RELEASE_SERVICE_VERSION_MINOR "12")
+set (RELEASE_SERVICE_VERSION_MICRO "3")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 # Do not increase these requirements without a merge-request or/and
@@ -37,13 +37,14 @@
 include(FeatureSummary)
 include(ECMQtDeclareLoggingCategory)
 include(KDEClangFormat)
-
+# Remove OPTIONAL when we require EMC >= 5.79
+include(KDEGitCommitHooks OPTIONAL)
 
 # Allows passing e.g. -DECM_ENABLE_SANITIZERS='address;undefined' to cmake.
 include(ECMEnableSanitizers)
 
 ecm_setup_version(${RELEASE_SERVICE_VERSION} VARIABLE_PREFIX KONSOLEPRIVATE
-    SOVERSION ${RELEASE_SERVICE_VERSION_MAJOR}
+    SOVERSION 1
 )
 find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED
     Core
@@ -109,6 +110,8 @@
 
 file(GLOB ICONS_SRCS "data/icons/*.png")
 
+option(ENABLE_PLUGIN_SSHMANAGER "Build the SSHManager plugin" ON)
+
 add_subdirectory( src )
 add_subdirectory( data )
 add_subdirectory( desktop )
@@ -131,18 +134,14 @@
     DESTINATION "${KDE_INSTALL_LOGGINGCATEGORIESDIR}"
 )
 
-option(ENABLE_PLUGIN_SSHMANAGER OFF)
-
 feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)
 
-# Do not do bulk whitespace/style changes without MRs and maintainer(s)
-# approval.  clang-format executeable needs to be installed prior to initial
-# building; then do make clang-format.
 # add clang-format target for all our real source files
 file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.c *.cpp *.h *.hpp)
 kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
-# Let's not do pre-hooks yet
-#kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
+if (ECM_VERSION VERSION_GREATER_EQUAL 5.79.0)
+    kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
+endif()
 ki18n_install(po)
 if (KF5DocTools_FOUND)
  kdoctools_install(po)

=== data/CMakeLists.txt ===

add_subdirectory( color-schemes )
add_subdirectory( keyboard-layouts )
add_subdirectory( layouts )

install( FILES konsole.knsrc DESTINATION ${KDE_INSTALL_KNSRCDIR})

=== data/keyboard-layouts/CMakeLists.txt ===
install( FILES
         default.keytab
         linux.keytab
         macos.keytab
         solaris.keytab
         DESTINATION
         ${KDE_INSTALL_DATADIR}/konsole )

=== src/autotests/CMakeLists.txt ===
--- 
+++ 
@@ -48,11 +48,14 @@
 add_test(NAME HistoryTest COMMAND HistoryTest)
 target_link_libraries(HistoryTest ${KONSOLE_TEST_LIBS} KF5::Parts)
 
+# Temporary bypass for BKO 432379
+if(BUILD_SHARED_LIBS)
 add_executable(KeyboardTranslatorTest KeyboardTranslatorTest.cpp)
 ecm_mark_as_test(KeyboardTranslatorTest)
 ecm_mark_nongui_executable(KeyboardTranslatorTest)
 add_test(NAME KeyboardTranslatorTest COMMAND KeyboardTranslatorTest)
 target_link_libraries(KeyboardTranslatorTest ${KONSOLE_TEST_LIBS})
+endif(BUILD_SHARED_LIBS)
 
 if (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
     add_executable(PartTest PartTest.cpp)

=== src/characters/CMakeLists.txt ===

set(konsolecharacters_SRCS
    CharacterFormat.cpp
    CharacterWidth.cpp
    LineBlockCharacters.cpp
    ExtendedCharTable.cpp
)

ecm_qt_declare_logging_category(
    konsolecharacters_SRCS
    HEADER charactersdebug.h
    IDENTIFIER CharactersDebug
    CATEGORY_NAME org.kde.konsole.characters
    DESCRIPTION "Konsole - characters"
    EXPORT KONSOLE
)

add_library(konsolecharacters OBJECT ${konsolecharacters_SRCS})
generate_export_header(konsolecharacters BASE_NAME konsolecharacters)
target_include_directories(konsolecharacters
    PUBLIC ${CMAKE_CURRENT_BINARY_DIR}
    INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(konsolecharacters Qt5::Gui)

=== src/colorscheme/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
     ColorSchemeWallpaper.cpp
     ColorSchemeEditor.cpp
     ColorSchemeViewDelegate.cpp
+    RandomizationRange.cpp
 )
 
 ki18n_wrap_ui(konsole_colorscheme_SRCS
@@ -17,6 +18,8 @@
     HEADER colorschemedebug.h
     IDENTIFIER ColorSchemeDebug
     CATEGORY_NAME org.kde.konsole.colorScheme
+    DESCRIPTION "Konsole - colorscheme"
+    EXPORT KONSOLE
 )
 
 add_library(konsolecolorscheme
@@ -24,7 +27,10 @@
     ${konsole_colorscheme_SRCS}
 )
 generate_export_header(konsolecolorscheme BASE_NAME konsolecolorscheme)
-target_include_directories(konsolecolorscheme PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
+target_include_directories(konsolecolorscheme
+    PUBLIC ${CMAKE_CURRENT_BINARY_DIR}
+    INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
+
 target_link_libraries(
     konsolecolorscheme
     ${konsole_LIBS}

=== src/plugins/CMakeLists.txt ===
if(ENABLE_PLUGIN_SSHMANAGER)
    add_subdirectory(SSHManager)
endif()

=== src/profile/CMakeLists.txt ===


add_library(konsoleprofile
OBJECT
    Profile.cpp
    ProfileCommandParser.cpp
    ProfileGroup.cpp
    ProfileList.cpp
    ProfileReader.cpp
    ProfileWriter.cpp
    ProfileManager.cpp
    ProfileModel.cpp
    ${konsoleprofile_SRCS}
)
generate_export_header(konsoleprofile BASE_NAME konsoleprofile)
target_include_directories(konsoleprofile PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(
    konsoleprofile
    ${konsole_LIBS}
    konsoleprivate_core
    konsolecolorscheme
    keyboardtranslator
    konsolehelpers
)

=== src/session/CMakeLists.txt ===
#TODO: This Needs TerminalDisplay. Perhaps we should create a library
# that has only TerminalDisplay and link with this one? It's a hard thing
# to do as currently SessionController depends on TerminalDisplay and
# TerminalDisplay depends on SessionController.

# qdbuscpp2xml -m  Session.h -o org.kde.konsole.Session.xml
# Generate dbus .xml files; do not store .xml in source folder
qt5_generate_dbus_interface(Session.h org.kde.konsole.Session.xml OPTIONS -m)

qt5_add_dbus_adaptor(
    sessionadaptors_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/org.kde.konsole.Session.xml
    Session.h
    Konsole::Session
)

set(konsole_session_SRCS
    ${sessionadaptors_SRCS}
    Session.cpp
    SessionController.cpp
    SessionDisplayConnection.cpp
    SessionGroup.cpp
    SessionListModel.cpp
    SessionManager.cpp
    SessionTask.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/org.kde.konsole.Session.xml
)

add_library(konsolesession
    OBJECT
    ${konsole_session_SRCS}
)
generate_export_header(konsolesession BASE_NAME konsolesession)
target_include_directories(konsolesession PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(
    konsolesession
    ${konsole_LIBS}
    konsoleprofile  # TODO: Must be removed from here, Used only for ProfileCommandParser::parse in SessionManager::sessionProfileCommandReceived
)

=== debian/changelog ===
konsole (4:21.12.3-0ubuntu1) jammy; urgency=medium

  * New upstream release (21.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Mar 2022 10:14:04 +0000

konsole (4:21.12.2-0ubuntu1) jammy; urgency=medium

  [ José Manuel Santamaría Lema ]
  * Update upstream signing key

  [ Rik Mills ]
  * New upstream release (21.12.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Feb 2022 07:20:38 +0000

konsole (4:21.12.1-0ubuntu1) jammy; urgency=medium

  * Drop included upstream patch.
  * New upstream release (21.12.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Jan 2022 10:28:29 +0000

konsole (4:21.12.0-0ubuntu2) jammy; urgency=medium

  * Add patch requested by upstream KDE:
    - debian/patches: upstream_fix-finding-default-profile.patch

 -- Rik Mills <rikmills@kde.org>  Mon, 03 Jan 2022 13:04:08 +0000

konsole (4:21.12.0-0ubuntu1) jammy; urgency=medium

  [ Rik Mills ]
  * New upstream release (21.12.0)
  * Set maintainer to Kubuntu Developers.

  [ José Manuel Santamaría Lema ]
  * Update upstream signing key

 -- Rik Mills <rikmills@kde.org>  Thu, 09 Dec 2021 11:25:40 +0000

konsole (4:21.11.90-0ubuntu2) jammy; urgency=medium

  * Add Kubuntu Vcs fields.

 -- Rik Mills <rikmills@kde.org>  Sun, 28 Nov 2021 19:10:11 +0000

konsole (4:21.11.90-0ubuntu1) jammy; urgency=medium

  * New upstream (RC) release (21.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 26 Nov 2021 13:20:51 +0000

konsole (4:21.11.80-0ubuntu1) jammy; urgency=medium

  * New upstream (beta) release (21.11.80)

 -- Rik Mills <rikmills@kde.org>  Sun, 21 Nov 2021 18:28:36 +0000

konsole (4:21.08.3-0ubuntu1) jammy; urgency=medium

  * New upstream release (21.08.3)

 -- Rik Mills <rikmills@kde.org>  Mon, 15 Nov 2021 09:43:17 +0000

konsole (4:21.08.2-1) unstable; urgency=medium
  [ Rik Mills ]
  * Fix mismatched and obsolete lintian overrides.

  [ Norbert Preining ]
  * New upstream release (21.08.2).

 -- Norbert Preining <norbert@preining.info>  Fri, 08 Oct 2021 12:56:58 +0900

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: konsole
 Section: kde
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
            Sune Vuorela <sune@debian.org>,
            Norbert Preining <norbert@preining.info>,
@@ -39,8 +40,8 @@
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://apps.kde.org/en/konsole
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/konsole
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/konsole.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/konsole
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/konsole
 
 Package: konsole
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF -DENABLE_PLUGIN_SSHMANAGER=ON

override_dh_auto_test:
	# Disable dh_auto_test at build time
	:

execute_before_dh_lintian:
	mkdir -p debian/.debhelper/konsole/dbgsym-root/usr/share/lintian/overrides/
	cp debian/konsole-dbgsym.lintian-overrides debian/.debhelper/konsole/dbgsym-root/usr/share/lintian/overrides/konsole-dbgsym

## konsole 22.08.2

=== debian/changelog ===
konsole (4:22.08.2-0ubuntu1) kinetic; urgency=medium

  * New upstream bugfix release (22.08.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 13 Oct 2022 08:14:36 +0100

konsole (4:22.08.1-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.08.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 08 Sep 2022 07:43:20 +0100

konsole (4:22.08.0-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.08.0)

 -- Rik Mills <rikmills@kde.org>  Wed, 24 Aug 2022 09:52:52 +0100

konsole (4:22.04.3-0ubuntu2) kinetic; urgency=medium

  * Update lintian overrides

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Tue, 02 Aug 2022 12:34:42 +0100

konsole (4:22.04.3-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 07 Jul 2022 09:30:36 +0100

konsole (4:22.04.2-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.04.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 09 Jun 2022 08:04:57 +0100

konsole (4:22.04.1-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.04.1)

 -- Rik Mills <rikmills@kde.org>  Wed, 11 May 2022 21:03:52 +0100

konsole (4:22.04.0-0ubuntu1) kinetic; urgency=medium

  * New upstream release (22.04.0)
  * Build depend on zlib1g-dev
  * Update install files.
  * Update lintian overrides.

 -- Rik Mills <rikmills@kde.org>  Mon, 02 May 2022 06:51:24 +0100

=== debian/control ===
--- 
+++ 
@@ -37,6 +37,7 @@
                libx11-dev,
                pkg-kde-tools (>= 0.15.16~),
                qtbase5-dev (>= 5.15.0~),
+               zlib1g-dev,
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://apps.kde.org/en/konsole
